#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_PublisherWebSocket_1" type="PublisherWebSocket" x="484" y="180">
      <Parameter name="ENABLE_EXPORT_DEBUG" type="bool" value="false" description="All socket message export to file."/>
      <Parameter name="EXPORT_FILENAME" type="string" value="EXPORT_DEBUG_FILE" description="Export filename."/>
      <Parameter name="ENABLE_STATUS_DEBUG" type="bool" value="false" description="robot status print debug message of this module in case of true."/>
      <Parameter name="ENABLE_SYNC_DEBUG" type="bool" value="false" description="synchronization print debug message of this module in case of true."/>
      <Parameter name="SERVER_MODE" type="bool" value="false" description="Select server/client mode. (Server is true, Client is false.) [default: true]."/>
      <Parameter name="USE_SSL" type="bool" value="false" description="SSL enable (wss://...) is true, SSL disable (ws://...) is false. [default: false]."/>
      <Parameter name="USE_DOS_ATTACK_GUARD" type="bool" value="false" description="You can set maximum receive frame size limitation enable. [default: false]."/>
      <Parameter name="LIMIT" type="int" value="65535" description="Port number of peer server/client node."/>
      <Parameter name="PEER_HOST" type="string" value="127.0.0.1" description="IP Address or Hostname of peer server/client node."/>
      <Parameter name="PEER_PORT" type="int" value="22000" description="Port number of peer server/client node."/>
      <Parameter name="DIR_SUFFIX" type="string" value="hark" description="Suffix for directory suffix. (Ex: ws://[IP_ADDRESS]:[PORT]/[DIR_SUFFIX])"/>
      <Parameter name="USE_TIMEOUT" type="bool" value="true" description="Kill whole hark network when this node does not take any message from server. If you set server mode, this item hidden."/>
      <Parameter name="TIMEOUT" type="int" value="500" description="If you use USE_TIMEOUT, set timeout for this network [ms]."/>
      <Parameter name="BUFFER_SIZE" type="int" value="100" description="Buffer save size for a HARK output. Too small value makes packet loss. Too large value takes large memory."/>
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="CHANNEL" type="int" value="4" description="The number of microphone."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="NUM_OF_STREAM" type="int" value="1" description="Number of in/out stream data."/>
      <Parameter name="STREAM_SELECTION_1" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM1_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM1_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM1_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM1_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_2" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM2_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM2_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM2_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM2_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_3" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM3_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM3_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM3_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM3_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_4" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM4_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM4_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM4_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM4_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_5" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM5_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM5_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM5_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM5_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_6" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM6_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM6_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM6_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM6_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_7" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM7_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM7_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM7_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM7_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_8" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM8_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM8_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM8_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM8_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_9" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM9_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM9_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM9_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM9_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_10" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM10_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM10_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM10_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM10_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_11" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM11_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM11_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM11_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM11_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_12" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM12_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM12_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM12_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM12_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_13" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM13_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM13_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM13_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM13_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_14" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM14_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM14_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM14_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM14_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_15" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM15_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM15_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM15_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM15_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
      <Parameter name="STREAM_SELECTION_16" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM16_PARAM_TYPE" type="string" value="Bool" description="This item is void, because this function is pending. Future function overview: Please select Input type from HarkDataObject or basic type of C."/>
      <Parameter name="STREAM16_PRAM_CONTROLTYPE" type="string" value="HoldAndUpdate" description="This item is void, because this function is pending. Future function overview: Please select Input value control type."/>
      <Parameter name="STREAM16_OVERLAPCONTROL" type="string" value="Through" description="This item is void, because this function is pending. Future function overview: If you want to force overlap, please select to Overlap. If you want to force dis-overlap, please select to DisOverlap. If you want to no processing, please select to Through. If you want to deliver only add overlaped data flag, please select to AddFlag."/>
      <Parameter name="STREAM16_MAP_SELECTION" type="string" value="MapIsFloat" description="Selector of map stream you want to realize. All other subscription will be disabled. This setting is valid only when the Map was entered. Other input is determined automatically."/>
    </Node>
    <Node name="node_AudioStreamFromMic_1" type="AudioStreamFromMic" x="154" y="180">
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="CHANNEL_COUNT" type="int" value="4" description="The number of channels."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="DEVICETYPE" type="string" value="ALSA" description="Device type [default: WS]."/>
      <Parameter name="GAIN" type="string" value="0dB" description="capture gain (dB)  [default: 0dB]."/>
      <Parameter name="DEVICE" type="string" value="plughw:1,0" description="Device name or IP address [default: 127.0.0.1]"/>
    </Node>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_PublisherWebSocket_1" input="IN_1"/>
    <Link from="node_AudioStreamFromMic_1" output="NOT_EOF" to="node_PublisherWebSocket_1" input="IN_CONDITION_SYNC"/>
    <NetOutput name="OUT_DUMMY" node="node_PublisherWebSocket_1" terminal="OUT_DUMMY" object_type="bool" description="Output for dummy. Value as same as OUT_CONDITION. This output need for execute this node."/>
    <NetCondition name="CONDITION" node="node_PublisherWebSocket_1" terminal="OUT_CONDITION"/>
  </Network>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="280" y="180">
    </Node>
    <NetOutput name="OUT_DUMMY" node="node_MAIN_LOOP_1" terminal="OUT_DUMMY" object_type="bool" description="Output for dummy. Value as same as OUT_CONDITION. This output need for execute this node."/>
  </Network>
</Document>
