#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_SubscriberWebSocket_1" type="SubscriberWebSocket" x="210" y="180">
      <Parameter name="ENABLE_STATUS_DEBUG" type="bool" value="false" description="robot status print debug message of this module in case of true."/>
      <Parameter name="ENABLE_SYNC_DEBUG" type="bool" value="false" description="synchronization print debug message of this module in case of true."/>
      <Parameter name="SERVER_MODE" type="bool" value="true" description="Select server/client mode. (Server is true, Client is false.) [default: true]."/>
      <Parameter name="USE_SSL" type="bool" value="false" description="SSL enable (wss://...) is true, SSL disable (ws://...) is false. [default: false]."/>
      <Parameter name="USE_DOS_ATTACK_GUARD" type="bool" value="false" description="You can set maximum receive frame size limitation enable. [default: false]."/>
      <Parameter name="LIMIT" type="int" value="65535" description="Port number of peer server/client node."/>
      <Parameter name="PEER_HOST" type="string" value="127.0.0.1" description="IP Address or Hostname of peer server/client node."/>
      <Parameter name="PEER_PORT" type="int" value="22000" description="Port number of peer server/client node."/>
      <Parameter name="DIR_SUFFIX" type="string" value="hark" description="Suffix for directory suffix. (Ex: ws://[IP_ADDRESS]:[PORT]/[DIR_SUFFIX])"/>
      <Parameter name="USE_TIMEOUT" type="bool" value="true" description="Kill whole hark network when this node does not take any message from server. If you set server mode, this item hidden."/>
      <Parameter name="TIMEOUT" type="int" value="500" description="If you use USE_TIMEOUT, set timeout for this network [ms]."/>
      <Parameter name="BUFFER_SIZE" type="int" value="100" description="Buffer save size for a HARK output. Too small value makes packet loss. Too large value takes large memory."/>
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="CHANNEL" type="int" value="4" description="The number of microphone."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="NUM_OF_STREAM" type="int" value="1" description="Number of in/out stream data."/>
      <Parameter name="STREAM_SELECTION_1" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM1_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_2" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM2_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_3" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM3_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_4" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM4_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_5" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM5_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_6" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM6_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_7" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM7_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_8" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM8_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_9" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM9_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_10" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM10_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_11" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM11_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_12" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM12_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_13" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM13_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_14" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM14_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_15" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM15_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
      <Parameter name="STREAM_SELECTION_16" type="string" value="DataStream" description="Selector of stream you want to realize. All other subscription will be disabled."/>
      <Parameter name="STREAM16_OVERLAPCONTROL" type="string" value="Through" description="If you want to force overlap, please select to Overlap. If you want to no processing, please select to Through. You can&#x27;t select Auto, because this function is pending."/>
    </Node>
    <Node name="node_SaveWavePCM_1" type="SaveWavePCM" x="580" y="180">
      <Parameter name="BASENAME" type="string" value="sep_" description="Basename of files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. int16 , int24 and float32 bits are supported."/>
    </Node>
    <Link from="node_SubscriberWebSocket_1" output="OUT_1" to="node_SaveWavePCM_1" input="INPUT"/>
    <NetCondition name="CONDITION" node="node_SubscriberWebSocket_1" terminal="OUT_CONDITION"/>
    <NetOutput name="OUTPUT" node="node_SaveWavePCM_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
  </Network>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="430" y="180">
    </Node>
    <NetOutput name="OUTPUT" node="node_MAIN_LOOP_1" terminal="OUTPUT" object_type="any" description="Dynamic"/>
  </Network>
</Document>
